package scacchi.prova;

import java.io.*;

import scacchi.main.Comando;
import scacchi.main.InterfacciaComandi;

import scacchi.main.ArgomentiComando.*;
import scacchi.main.EccezioniTesto.*;
import scacchi.main.EccezioniPartita.*;

/**
 * Implementa {@link InterfacciaComandi} per {@link ComandoScacchi}.
 * @see Comando
 * @see ComandoScacchi
 * @see InterfacciaComandi
 */
public class InterfacciaComandiScacchi extends InterfacciaComandi {

    /**
     * Crea una nuova interfaccia associata allo stream dello
     * standard input.
     */
    public InterfacciaComandiScacchi() {};

    /**
     * Crea una nuova interfaccia.
     * @param in lo stream di caratteri da cui l'interfaccia legge l'input.
     */
    public InterfacciaComandiScacchi(Reader in) { super(in); }

    /**
     * Crea una nuova istanza di {@link ComandoScacchi}
     */
    public Comando nuovoComando(String s) throws NotazioneException {
	return new ComandoScacchi(s);
    }
}
