package scacchi.soluzione;

import scacchi.main.Partita;
import scacchi.main.ArgomentiComando.*;
import scacchi.main.EccezioniTesto.*;
import scacchi.main.EccezioniPartita.*;

/**
 * Implementazione della interfaccia
 * {@link scacchi.main.Partita} che implementa le regole del gioco degli
 * scacchi.
 */

/*
 * This project was developed by:
 * Marco Valerio "l'acheeeer" Barbera 
 * Alessandro "Il Dormiente" Cammarano
 * Andrea "Il Maestro" Cerone
 * ve l'avevo detto che avrei inserito un commento del genere :P
 */

public class PartitaScacchi implements Partita {
	/**
	* Crea una nuova partita che comincia dalla posizione iniziale del gioco.
	*/

	info log;

	public PartitaScacchi() {
			log = new info();
	}

	/**
	* Crea una nuova partita che comincia da una posizione data.
	* @param n Il numero di mossa da cui comincia la partita. Se positivo
	*          il tratto &egrave; al BIANCO, se negativo al NERO.
	* @param l La lista delle posizioni dei pezzi che descrive la
	*          posizione di inizio della partita.
	* @throws scacchi.main.EccezioniPartita.PosizioneInizialeException
	*         Se la posizione di partenza non verifica le seguenti
	*         condizioni:
	*         <ol>
	*         <li>nella posizione ci sono un (solo) Re BIANCO ed un
	*             (solo) Re NERO</li>
	*         <li>il Re del giocatore che non ha il tratto non &egrave;
	*             sotto scacco</li>
	*         <li>la pozione non contiene pedoni (di alcun colore) nella
	*             prima ed ottava traversa</li>
	*         </ol>
	*/
	public PartitaScacchi(int n, ListaPosPezziTesto l)
		throws PosizioneInizialeException {}

	public int getNumMossa() {
		return log.mossa;
	}

	public ListaPosPezziTesto eseguiMossa(MossaTesto m)
		throws MossaException {
			String mossevalide= getMosseValide().toString();
			for (int i=0; i < mossevalide.length(); i += 5) {
				String mossa = mossevalide.substring(i, i+4);
				System.out.println(mossa + " " + m);
				if (mossa.equals(m.toString())) {
					log.update(m);
					return log.LPPT;
				}
			}
			throw new MossaException(m, "Mossa Non Valida");
	};

    public ListaPosPezziTesto tornaIndietro()
	throws NoMoreMosseException {
		log.torna();
		return log.LPPT;
	}

    public ListaPosPezziTesto tornaIndietro(int n)
	throws NoMoreMosseException {
		for(int c = 0; c < n; c++) // c/c++ is better than java
			log.torna();
		return log.LPPT;
	}

    public ListaMosseTesto listaMosse() {
/*		System.out.println(log.ListaPezzi(BIANCO).toString());
		CasaTesto c = null;
		try { c = new CasaTesto("d2");
		} catch (NotazioneException ne) {
		System.out.println("fuck");
		};
*		getMossePossibili(c); 
			if (scaccoAlRe())
				System.out.println("Re sotto Scacco");
		System.out.println(getMossePossibili().toString());
	    */	return log.LMT;
    }

    public ListaMosseTesto listaMosse(int n)
	throws NoMoreMosseException { return null; }

	public ListaPosPezziTesto getPosizionePezzi() {
		return log.LPPT;
	}

	int casaVuota(int[] coord) {
		String lppttemp = log.LPPT.toString();
		lppttemp += " ";
		int index = lppttemp.indexOf(scoordinate(coord));
		if(index != -1) {
			return index + 1;
		}
		else {
			return 0;
		}
	}

	public ListaCaseTesto caseControllate(CasaTesto c)
	throws CasaVuotaException {
		ListaCaseTesto LCT = null;
		String lppttemp = log.LPPT.toString();
		int[] coord = coordinate(c);
		int[] coord2 = new int[2];
		String controllate = new String("");
		int index = casaVuota(coord);
		if(index == 0)
			throw new CasaVuotaException(c);
		int colore = 1; // bianco
		char y = lppttemp.charAt(index - 2);
		Character x = new Character(y);
		if(x.isLowerCase(x.charValue()))
			colore = 2; // nero
		y = x.toLowerCase(x.charValue());
		switch(y) {
			case  'p':
				if(colore == 1) {
					if(coord[0] > 1) {
						coord2[0] = coord[0] - 1;
						coord2[1] = coord[1] + 1;
						log.aggiornaMatrice(coord2, colore);
						controllate += scoordinate(coord2);
					}

					if(coord[0] < 8) {
						coord2[0] = coord[0] + 1;
						coord2[1] = coord[1] + 1;
						log.aggiornaMatrice(coord2, colore);
						controllate += scoordinate(coord2);
					}
				}

				if(colore == 2) {
					if(coord[0] > 1) {
						coord2[0] = coord[0] - 1;
						coord2[1] = coord[1] - 1;
						log.aggiornaMatrice(coord2, colore);
						controllate += scoordinate(coord2);
					}

					if(coord[0] < 8) {
						coord2[0] = coord[0] + 1;
						coord2[1] = coord[1] - 1;
						controllate += scoordinate(coord2);
						log.aggiornaMatrice(coord2, colore);
					}
				}
			break;

			case 'c':
				if(coord[0] > 1 && coord[1] < 7) {
					coord2[0] = coord[0] - 1;
					coord2[1] = coord[1] + 2;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 8 && coord[1] < 7) {
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1] + 2;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 7 && coord[1] < 8) {
					coord2[0] = coord[0] + 2;
					coord2[1] = coord[1] + 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 7 && coord[1] > 1) {
					coord2[0] = coord[0] + 2;
					coord2[1] = coord[1] - 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 8 && coord[1] > 2) {
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1] - 2;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 1 && coord[1] > 2) {
					coord2[0] = coord[0] - 1;
					coord2[1] = coord[1] - 2;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 2 && coord[1] > 1) {
					coord2[0] = coord[0] - 2;
					coord2[1] = coord[1] - 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 2 && coord[1] < 8) {
					coord2[0] = coord[0] - 2;
					coord2[1] = coord[1] + 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
			break;
			// miiii che fatica

			case 'r':
				if(coord[1] < 8) {
					coord2[0] = coord[0];
					coord2[1] = coord[1] + 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 8 && coord[1] < 8) {
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1] + 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 8) {
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1];
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 8 && coord[1] > 1) {
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1] - 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[1] > 1) {
					coord2[0] = coord[0];
					coord2[1] = coord[1] - 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 1 && coord[1] > 1) {
					coord2[0] = coord[0] - 1;
					coord2[1] = coord[1] - 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 1) {
					coord2[0] = coord[0] - 1;
					coord2[1] = coord[1];
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 1 && coord[1] <= 7) {
				// perche' siamo acheeeeer
					coord2[0] = coord[0] - 1;
					coord2[1] = coord[1] + 1;
					log.aggiornaMatrice(coord2, colore);
					controllate += scoordinate(coord2);
				}
			break;
			// copia&incolla rules

			case 't':
				controllate = Rat(coord, 1, colore);
			break;

			case 'a':
				controllate = Rat(coord, -1, colore);
			break;

			case 'd':
				controllate = Rat(coord, 0, colore);
			break;
		}

		try {
			LCT = new ListaCaseTesto(controllate);
		} catch(NotazioneException ne) {
			System.out.println("notazione exception case controllate");
		}

    //	log.stampaMatrice();
	return LCT;
	}

	private	int[] coordinate(CasaTesto c) {
		int riga, colonna;
		char x;
		x = c.toString().charAt(0);
		colonna = (int)(x - 'a') + 1;
		x = c.toString().charAt(1);
		riga = (int)(x - '1') + 1;
		int[] coordinate = { colonna, riga };
		return coordinate;
	}

	private String scoordinate(int[] coordinate) {
		String S = new String("");
		Character C = new Character((char)(coordinate[0] - 1 + 'a'));
		S += C.toString();
		C = new Character((char)(coordinate[1] - 1 + '1'));
		S += C.toString() + " ";
		return S;
	}

	private String Rat(int[] coord, int pezzo, int colore) {
		int[] coord2 = {coord[0], coord[1]};
		String ret = new String("");
		String add = new String("");
		if(pezzo > -1) {
			for(int i = coord[0] + 1; i < 9; i++) {

				coord2[0] = i;
				coord2[1] = coord[1];
				log.aggiornaMatrice(coord2, colore);
				add = scoordinate(coord2);
				ret += add;
				if(casaVuota(coord2) != 0) {
					break;
				}
			}


			for(int i = coord[0] - 1; i > 0; i--) {
				coord2[0] = i;
				coord2[1] = coord[1];
				log.aggiornaMatrice(coord2, colore);
				add = scoordinate(coord2);
				ret += add;
				if(casaVuota(coord2) != 0) {
					break;
				}
			}

			for(int i = coord[1] + 1; i < 9; i++) {
				coord2[0] = coord[0];
				coord2[1] = i;
				log.aggiornaMatrice(coord2, colore);
				add = scoordinate(coord2);
				ret += add;
				if(casaVuota(coord2) != 0)
					break;
			}

			for(int i = coord[1] - 1; i > 0; i--) {
				coord2[1] = i;
				coord2[0] = coord[0];
				log.aggiornaMatrice(coord2, colore);
				ret += scoordinate(coord2);
				if(casaVuota(coord2) != 0)
					break;
			}
		}

		if(pezzo < 1) {
			int j=1;
			for(int i = coord[0] + 1; i < 9; i++) {
				coord2[0] = i;
				coord2[1] = coord[1] + j;
				if (coord2[1] > 8)
					break;
				log.aggiornaMatrice(coord2, colore);
				ret += scoordinate(coord2);

				j++;
				if(casaVuota(coord2) != 0)
					break;
			}

			j = 1;
			for(int i = coord[0] - 1; i > 0; i--) {
				coord2[0] = i;
				coord2[1] = coord[1] - j ;
				if (coord2[1] < 1)
					break;
				log.aggiornaMatrice(coord2, colore);
				ret += scoordinate(coord2);
				j++;
				if(casaVuota(coord2) != 0)
					break;
			}

			j = 1;
			for(int i = coord[0] + 1; i < 9; i++) {
				coord2[0] = i;
				coord2[1] = coord[1] - j;
				if (coord2[1] < 1)
					break;
				ret += scoordinate(coord2);
				j++;
				if(casaVuota(coord2) != 0)
					break;
			}
			j = 1;
			for(int i = coord[0] - 1; i > 0; i--) {
				coord2[0] = i;
				coord2[1] = coord[1] + j;
				if (coord2[1] > 8)
					break;
				ret += scoordinate(coord2);
				j++;
				if(casaVuota(coord2) != 0)
					break;
			}
		}
	// se non funziona e' colpa di anDrea ceRone
	return ret;

	}

	public ListaCaseTesto caseControllate(boolean colore) {
		CasaTesto auxc = null;
		String ret = new String("");
		String aux;
		ListaCaseTesto R = null;
		int length = log.LPPT.toString().length();
		String support = new String(log.LPPT.toString());
		char[] posizione = support.toCharArray();

		for(int i = 0; i < length; i += 4) {
			if(colore == BIANCO && posizione[i] <= 'Z' && posizione[i] >= 'A') {
				aux = new String(posizione, i+1, 2);
				try {
					auxc = new CasaTesto(aux);
				} catch(NotazioneException ne) {
					System.out.println("exception 0 in caseControllate");
				}

				try {
					ret += caseControllate(auxc).toString() + " ";
				} catch (CasaVuotaException ce) {
					System.out.println("exception 1 in caseControllate");
				}
			}
			if(colore == NERO && posizione[i] <= 'z' && posizione[i] >= 'a') {
				aux = new String(posizione, i+1, 2);
				try {
					auxc = new CasaTesto(aux);
				} catch(NotazioneException ne) {
					System.out.println("exception 2 in caseControllate");
				}
				try {
					ret += caseControllate(auxc).toString() + " ";
				} catch (CasaVuotaException ce) {
					System.out.println("exception 3 in caseControllate");
				}
			}
		}


		length = ret.length();
		posizione = ret.toCharArray();
		for (int i = 0; i < length; i += 3) {
			aux = new String(posizione, i, 2);
			char[] pos2 = aux.toCharArray();
			for (int j = i+3; j < length; j += 3) {
				if (posizione[j] == pos2[0] && posizione[j+1] == pos2[1])
					posizione[j] = posizione[j+1] = ' ';
			}
		}
		ret = new String(posizione);


		try {
			R = new ListaCaseTesto(ret);
		} catch (NotazioneException ne) {
			System.out.println("exception 4 in caseControllate");
		}


		return R;
	}


    public ListaCaseTesto caseControllate() {

		String ret = new String(caseControllate(BIANCO).toString() + " " + caseControllate(NERO).toString());
		ListaCaseTesto R = null;
		int length = ret.length();
		char[] posizione = ret.toCharArray();
		for (int i = 0; i < length; i += 3) {
			String aux = new String(posizione, i, 2);
			char[] pos2 = aux.toCharArray();
			for (int j = i+3; j < length; j += 3) {
				if (posizione[j] == pos2[0] && posizione[j+1] == pos2[1])
					posizione[j] = posizione[j+1] = ' ';
			}
		}
		ret = new String(posizione);
		try {
			R = new ListaCaseTesto(ret);
		} catch(NotazioneException ne) {
			System.out.println("Notazione Exception in CaseControllate(void)");
		}
		return R;
    	}

    public ListaPosPezziTesto casaControllataDa(CasaTesto c, boolean colore) { //debugging enabled!
    	ListaPosPezziTesto RET = null;
	CasaTesto DaControllare = null;
	String Soluzione = new String("");
	String Casastringa = new String(c.toString());
	String PezziStringa = new String(log.LPPT.toString());
	for (int j = 0; j < PezziStringa.length(); j += 4) { // prendiamo 4 caratteri a volta es : 'Dd8 '
		String Casa = PezziStringa.substring(j + 1, j + 3); //sottostringa contenente la casa es : 'd8'
		//Casa e' la casa dove risiede il pezzo che stiamo controllando
		Character ColorPezzo = new Character(PezziStringa.charAt(j)); // conterra' il carattere identificativo del pezzo es :'D'
		//se ColorPezzo e' maiuscolo il pezzo e' bianco, altrimenti e' nero;
		
		boolean ColorID =BIANCO;
		if (ColorPezzo.isLowerCase(ColorPezzo.charValue())== true)
			ColorID = NERO;
			
		try {
			DaControllare = new CasaTesto(Casa);


			} catch(NotazioneException ne) {
				System.out.println("Notazione Exception 0 in caseControllateDa");
			}
		//a questo punto DaControllare e' il nostro oggetto su cui dobbiamo eseguire la verifica
		if (colore != ColorID )
			continue; //salta la parte finale del ciclo se il pezzo non appartiene al colore che stiamo controllando
		//vedere l'eccezione casaVuota
		String caselleControllate = null;
		try {
			caselleControllate = new String(caseControllate(DaControllare).toString() + " ");
			} catch(CasaVuotaException c2 ) {
				System.out.println("Exception 1 in CaseControllateDa");
			}
		//caselleControllate conterra la stringa delle case controllate dal pezzo nella casa DaControllare
		for (int x = 0; x < caselleControllate.length(); x += 3) { // si considerano tre caratteri alla volta, ognuno dei quali si riferisce a una casella
			if(Casastringa.equals(caselleControllate.substring(x, x + 2))) {
				Soluzione += PezziStringa.substring(j, j + 4); // usando j = 4 viene inserito automaticamente anche lo spazio
				break; //la verifica su questo pezzo e' stata terminata: rompi il ciclo e continua col prossimo pezzo
				}
			}
		}
		// arrivati a questo punto Soluzione dovrebbe contenere la stringa con i pezzi che controllano la casa c
		try {
			RET = new ListaPosPezziTesto(Soluzione);
			} catch(NotazioneException ne) {
				System.out.println("Notazione Exception 2 in CasaControllataDa");
			}
		return RET;
		// se questa cosa funziona ve l'ho fatta 10 volte meno incasinata e 20 piu' corta di come la stavate facendo voi
		// quindi molto probabilmente NON FUNZIONERA'
		// ma se funziona SONO UN ACHEEEEEEEEEEEERRRR!!!

	}

	public ListaCaseTesto getMossePossibili(CasaTesto c) {
		int[] coord;
		String Soluzione = new String("");
		String casa = c.toString(), pezzi = log.LPPT.toString(), x = null;
		Character pezzo = null;
		CasaTesto D = null;
		
		/* cerco la pedina nella scacchiera */
		for(int i = 0; i < pezzi.length(); i += 4) {
			x = pezzi.substring(i + 1, i + 3);
			if(x.equals(casa) == true) {
			 pezzo = new Character(pezzi.charAt(i));
			 break;
			}
		}
	
		//a questo punto pezzo dovrebbe contenere il carattere del
		//pezzo contenuto nella casa c
		if (pezzo.charValue() == 'P' || pezzo.charValue() == 'p') { //caso del pedone
			if(pezzo.charValue() == 'P') { //caso del pedone bianco
				coord = coordinate(c);
				coord[1]++;
				String S = new String(scoordinate(coord));
				if (casaVuota(coord) == 0) {
					Soluzione += S + " ";
					if (x.charAt(1) == '2') {
						coord[1]++;
						S = new String(scoordinate(coord));
						if (casaVuota(coord) == 0)
							Soluzione += S + " ";
					} //abbiamo controllato le mosse in avanti
				}	  //per un pedone bianco
			}
		
			if(pezzo.charValue() == 'p') { //caso del pedone nero
				coord = coordinate(c);
				coord[1]--;
				String S = new String(scoordinate(coord));
				if (casaVuota(coord) == 0) {
					Soluzione += S + " ";
					if (x.charAt(1) == '7') {
						coord[1]--;
						S = new String(scoordinate(coord));
						if (casaVuota(coord) == 0)
							Soluzione += S + " ";
					} //abbiamo controllato le mosse in avanti
				}	  //per un pedone nero
			}
			String temp = null;
			try {
				temp=caseControllate(c).toString();
			} catch(CasaVuotaException ne) {
				System.out.println("Casa Vuota Exception 0 in getMossePossibili");
			} //prendiamo le case dove puo' essere effettuata una cattura
			for (int j = 0; j < temp.length() ; j += 3) { //scorriamo tali case una alla volta
				String temp2 = new String(temp.substring(j, j+2)); //prendiamo la casa che stiamo considerando
				try { D = new CasaTesto(temp2); //D sara' la casa da controllare
				} catch(NotazioneException ne) {
				System.out.println("NotazioneException 4 in getMossePossibili"); 
				}
				if ((log.coloreCasa(D) != log.coloreCasa(c)) && log.coloreCasa(D) != 0) {
					//la casa e' occupata da un pezzo avversario o e' vuota, dunque posso muovere lì
					Soluzione += temp2 + " "; //aggiungo la casa considerata alla lista delle mosse possibili
				}
			}	
			ListaCaseTesto ret = null;
			try {
				ret = new ListaCaseTesto(Soluzione);
			} catch(NotazioneException ne) {
				System.out.println("Notazione Exception 5 in getMossePossibili");
			}
			return ret; //ritorniamo la lista delle case dove il pezzo puo' muovere;
		}
		
		String temp = null;
		try {
			temp = caseControllate(c).toString();
		} catch(CasaVuotaException ne) {
			System.out.println("Casa Vuota Exception 0 in getMossePossibili");
		} //prendiamo le case dove puo' essere effettuata una cattura
	
		for (int j = 0; j < temp.length() ; j += 3) { //scorriamo tali case una alla volta
			String temp2 = new String(temp.substring(j, j + 2)); //prendiamo la casa che stiamo considerando
			try { D = new CasaTesto(temp2); // D sara' la casa da controllare
			} catch(NotazioneException ne) {
				System.out.println("NotazioneException 4 in getMossePossibili"); 
			}
			if (log.coloreCasa(D) != log.coloreCasa(c)) {
				//la casa e' occupata da un pezzo avversario o e' vuota, dunque posso muovere la'
				Soluzione += temp2 + " "; //aggiungo la casa considerata alla lista delle mosse possibili
			}
		}	
		ListaCaseTesto ret = null;
		try {
			ret = new ListaCaseTesto(Soluzione);
		} catch(NotazioneException ne) {
			System.out.println("Notazione Exception 5 in getMossePossibili");
		}
		return ret; //ritorniamo la lista delle case dove il pezzo puo' muovere;
	}

    public ListaPosPezziTesto casaControllataDa(CasaTesto c) {
    	ListaPosPezziTesto Soluzione = null;
	String SB = new String(casaControllataDa(c, BIANCO).toString());
	String SN = new String(casaControllataDa(c, NERO).toString());
	try {
		Soluzione = new ListaPosPezziTesto(SB + " " + SN);
		} catch (NotazioneException ne) {
			System.out.println("Notazione exception in CasaControllataDa(c)");
		}
	return Soluzione;
	}
	
	public ListaMosseTesto getMossePossibili() {
	ListaMosseTesto ret = null;
	String lmts = new String(""), lppts = log.LPPT.toString(); 
	boolean colore = log.mossa > 0 ? BIANCO : NERO;

		/* esamino uno ad uno i pezzi sulla scacchiera */
		for(int i = 0; i < lppts.length(); i += 4) {
			char pezzo = lppts.charAt(i);
			String casa = lppts.substring(i + 1, i + 3);
			CasaTesto ct = null;
			try {
				ct = new CasaTesto(casa);
			} catch(NotazioneException ne) {
				System.out.println("NotazioneException in GetMossePossibili()");
			}

			/* prendo le mosse possibili ed aggiungo a lmts */
			if((colore == BIANCO && pezzo >= 'A' && pezzo <= 'Z') ||
			   (colore == NERO && pezzo >= 'a' && pezzo <= 'z')) {
				ListaCaseTesto lct = getMossePossibili(ct);
				String lcts = lct.toString();
				for(int j = 0; j < lcts.length(); j += 3) 
					lmts += casa + lcts.substring(j, j + 2) + " ";
			}
		}

		try {
			ret = new ListaMosseTesto(lmts);
		} catch(NotazioneException ne) {
			System.out.println("NotazioneException in GetMossePossibili()");
		}
				
		return ret;

	}


	public ListaMosseTesto getMosseValide(CasaTesto c) {
		ListaMosseTesto ret = null;
		MossaTesto mt = null;
		String lmts = new String("");
		String mosse = getMossePossibili().toString();
		String casa, mossa;
	
		/* scorro tutte le mosse possibili del colore corrente */
		for(int i = 0; i < mosse.length(); i += 5) {
			casa = mosse.substring(i, i + 2);
			mossa = mosse.substring(i, i + 4);

			/* se la casa della mossa corrente corrisponde
			 * a quella richiesta allora controllo che la
			 * mossa sia anche valida
			 */
			if(casa.equals(c.toString())) {
		

				/* provo ad eseguire la mossa.. */
				try {
					mt = new MossaTesto(mossa);
					log.update(mt);
				} catch(NotazioneException ne) {
					System.out.println("NotazioneException in getMosseValide(CasaTesto c)");
				} 

				/* se la mossa mette il re sotto scacco
				 * la annullo altrimenti la aggiungo
				 */
				log.mossa = -log.mossa;
				if(!scaccoAlRe())
					lmts += mossa + " ";
				log.mossa = -log.mossa;
				try {
					log.torna();
				} catch(NoMoreMosseException me) {
					System.out.println("NoMoreMosseException in getMosseValide(CasaTesto c)");
				}	
			}
		}

		/* creo l'oggetto da tornare */
		try {
			ret = new ListaMosseTesto(lmts);
		} catch(NotazioneException ne) {
			System.out.println("NotazioneException in getMosseValide(CasaTesto c)");
		}
		
		return ret;
	}
					
	public ListaMosseTesto getMosseValide() {
		ListaMosseTesto ret = null;
		String casa, lppts, lmts = new String("");
		lppts = log.ListaPezzi(log.mossa > 0 ? BIANCO : NERO).toString();
		CasaTesto ct = null;
		
		for(int i = 0; i < lppts.length(); i += 4) {
			casa = lppts.substring(i + 1, i + 3);
			try {
				ct = new CasaTesto(casa);
			} catch(NotazioneException ne) {
				System.out.println("NotazioneException in getMosseValide()");
			}
			lmts += getMosseValide(ct).toString() + " ";
		}

		try {
			ret = new ListaMosseTesto(lmts);
		} catch(NotazioneException ne) {
			System.out.println("NotazioneException in getMosseValide()");
		}	
		
		return ret;
		
	}

    public boolean scaccoAlRe() {
    	CasaTesto CasaRe = null;
	ListaPosPezziTesto scacchi = null; //lista dei pezzi che tengono sotto scacco il re 
    	Character Re = new Character('r');
	boolean colore = BIANCO;
	if (log.mossa > 0) {
		Re = new Character('R');
		colore = NERO;
	}
	String PezziGiocanti = log.LPPT.toString();
	for (int j = 0; j< PezziGiocanti.length(); j += 4) {
		if (Re.charValue() == PezziGiocanti.charAt(j)) { //ho trovato il re del colore che cercavo  
			try {
				CasaRe = new CasaTesto(PezziGiocanti.substring(j+1, j+3)); //raccolgo le informazioni sulla casa del re
	 		} catch(NotazioneException ne) {
				System.out.println("Notazione Exception in ScaccoAlRe()");
			}
			try {
				scacchi = new ListaPosPezziTesto(casaControllataDa(CasaRe, colore).toString()); //vedo quali pezzi tengono il re sotto scacco
			} catch(NotazioneException ne) {
				System.out.println("Notazione Exception 2 in ScaccoAlRe()");
			}
			break; //esci dal ciclo
		}
	}
	if (scacchi.toString().length() == 0) 
		return false; //il re non è sotto scacco 
	return true;	    
    };
}


class info {

	static final boolean BIANCO = true;
	static final boolean NERO = false;
	ListaMosseTesto LMT;
	ListaCaseTesto LCT;
	ListaPosPezziTesto LPPT;
	ListaPosPezziTesto[] LPPTarray = new ListaPosPezziTesto[300];
	int mossa, count = 0;
	int[][] colorMatrice = new int[9][9];

	info() {
		try {
			LMT = new ListaMosseTesto("");
			LCT = new ListaCaseTesto("");
			mossa = 1;
			LPPT = new ListaPosPezziTesto("Ta1 Cb1 Ac1 Dd1 Re1 Af1 Cg1 Th1 Pa2 Pb2 Pc2 Pd2 Pe2 " +
						      "Pf2 Pg2 Ph2 ta8 cb8 ac8 dd8 re8 af8 cg8 th8 pa7 pb7 " +
						      "pc7 pd7 pe7 pf7 pg7 ph7 ");
		} catch(NotazioneException ne) {
			System.out.println("info exception");
		}
	}

	int coloreCasa(CasaTesto c) {
		String lppts = new String(LPPT.toString());
		String cs = c.toString();
//		System.out.print("la casa " + cs + ": ");
		for(int i = 0; i < lppts.length(); i += 4) {
			if(lppts.substring(i + 1, i + 3).equals(cs)) {
				char pezzo = lppts.charAt(i);
				if(pezzo >= 'a' && pezzo <= 'z') {
					return 1;
				}
				else {
					return 2;
				}
			}
		}
		return 0;
	}
	
	void aggiornaMatrice(int[] coordinate, int colore) {
		if(colorMatrice[coordinate[1]][coordinate[0]] == 0)
			colorMatrice[coordinate[1]][coordinate[0]] = colore;

		if(colorMatrice[coordinate[1]][coordinate[0]] == 1 && colore == 2)
			colorMatrice[coordinate[1]][coordinate[0]] = 3;


		if(colorMatrice[coordinate[1]][coordinate[0]] == 2 && colore == 1)
			colorMatrice[coordinate[1]][coordinate[0]] = 3;
	}

	void stampaMatrice() {
		for(int i = 1; i < 9; i++) {
			for(int ciao = 1; ciao < 899 - 890; ciao++)
				System.out.print(colorMatrice[i*i/i][ciao]);
			System.out.println("");
		}
	}

	ListaPosPezziTesto ListaPezzi(boolean colore) {
		char[] lista = (LPPT.toString() + " ").toCharArray();
		String help = new String("");
		ListaPosPezziTesto ret = null;
		for(int i = 0; i < lista.length; i += 4) {
				if(colore == BIANCO && lista[i] >= 'A' && lista[i] <= 'Z') 
						help += new String(lista, i, 4);
				
				else  if(colore == NERO && lista[i] <= 'z' && lista[i] >= 'a')
					help += new String(lista, i, 4);
		}

 		try { 
			ret = new ListaPosPezziTesto(help);
		} catch (NotazioneException ne) {
				System.out.println("Notazione exception in ListaPezzi");
		}

		return ret;
	}

	void update(MossaTesto MT) {
		String lppttemp, lmttemp;
		int index;

		lmttemp = LMT.toString();
		lmttemp = lmttemp + " " + (MT.toString());

		lppttemp = LPPT.toString();
		try {
			LPPTarray[count] =  new ListaPosPezziTesto(lppttemp);
		} catch(NotazioneException ne) {
			System.out.println("info update exeption");
		}

		index = lppttemp.indexOf(MT.toString().substring(2,4));
		if(index != -1)
			lppttemp = lppttemp.replaceAll(lppttemp.substring(index-1, index+2), "");

		lppttemp = lppttemp.replaceAll(MT.toString().substring(0,2), MT.toString().substring(2,4));

		try {
			LMT = new ListaMosseTesto(lmttemp);
			LPPT = new ListaPosPezziTesto(lppttemp);
		} catch(NotazioneException ne) {
			System.out.println("info update exeption");
		}

		mossa = mossa > 0 ? (-mossa) : (-mossa) + 1;
		count++;
		colorMatrice = new int[9][9];

	}

	void torna() throws NoMoreMosseException {
		if(count == 0)
			throw new NoMoreMosseException();
		else {
			count--;
			LPPT = LPPTarray[count];
		}

		String lmttemp, lmttemp2;
		lmttemp = LMT.toString();
		try {
			LMT = new ListaMosseTesto(lmttemp.substring(0, (lmttemp.length())-4));
		} catch (NotazioneException ne) {
			System.out.println("info torna exception");
		}
		mossa = mossa > 0 ? (-mossa) + 1 : -mossa;
	}

}

